diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
index 4f240d56e..cb0ba48cd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
@@ -1,52 +1,48 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.Global;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.joml.Math;
 
 import java.util.Random;
 
-public class EntityRendererPainting extends EntityRenderer<EntityPainting>
-{
+public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
     private static final IconCoordinate paintingBack = TextureRegistry.getTexture("minecraft:art/backing");
-    public EntityRendererPainting()
-    {
-        rand = new Random();
+
+    public EntityRendererPainting() {
+        this.rand = new Random();
     }
 
-    private void renderArt(Tessellator tessellator, EntityPainting entity, int sizeX, int sizeY, IconCoordinate iconCoordinate) {
+    private void renderArt(TessellatorGeneral tessellator, EntityPainting entity, int sizeX, int sizeY, IconCoordinate iconCoordinate) {
         iconCoordinate.parentAtlas.bind();
-        final float negCenterX = (float)(-sizeX) / 2.0F;
-        final float negCenterY = (float)(-sizeY) / 2.0F;
+        final float negCenterX = (float) (-sizeX) / 2.0F;
+        final float negCenterY = (float) (-sizeY) / 2.0F;
         final float minZ = -0.5F;
         final float maxZ = 0.5F;
 
         final int tilesX = sizeX / 16;
         final int tilesY = sizeY / 16;
 
-        for(int x = 0; x < tilesX; x++)
-        {
-            for(int y = 0; y < tilesY; y++)
-            {
-                final float maxX = negCenterX + (float)((x + 1) * 16);
-                final float minX = negCenterX + (float)(x * 16);
-                final float maxY = negCenterY + (float)((y + 1) * 16);
-                final float minY = negCenterY + (float)(y * 16);
+        for (int x = 0; x < tilesX; x++) {
+            for (int y = 0; y < tilesY; y++) {
+                final float maxX = negCenterX + (float) ((x + 1) * 16);
+                final float minX = negCenterX + (float) (x * 16);
+                final float maxY = negCenterY + (float) ((y + 1) * 16);
+                final float minY = negCenterY + (float) (y * 16);
                 setupPaintingBrightness(entity, (maxX + minX) / 2.0F, (maxY + minY) / 2.0F);
-                final double frontMinU = iconCoordinate.getSubIconU((tilesX - x) / (sizeX/16f));
-                final double frontMaxU = iconCoordinate.getSubIconU((tilesX - x - 1) / (sizeX/16f));
-                final double frontMinV = iconCoordinate.getSubIconV((tilesY - y) / (sizeY/16f));
-                final double frontMaxV = iconCoordinate.getSubIconV((tilesY - y - 1) / (sizeY/16f));
+                final double frontMinU = iconCoordinate.getSubIconU((tilesX - x) / (sizeX / 16f));
+                final double frontMaxU = iconCoordinate.getSubIconU((tilesX - x - 1) / (sizeX / 16f));
+                final double frontMinV = iconCoordinate.getSubIconV((tilesY - y) / (sizeY / 16f));
+                final double frontMaxV = iconCoordinate.getSubIconV((tilesY - y - 1) / (sizeY / 16f));
                 final double backMinU = paintingBack.getIconUMin();
                 final double backMaxU = paintingBack.getIconUMax();
                 final double backMinV = paintingBack.getIconVMin();
@@ -63,7 +59,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
                 tessellator.addVertexWithUV(minX, minY, maxZ, backMaxU, backMaxV);
                 tessellator.addVertexWithUV(maxX, minY, maxZ, backMinU, backMaxV);
 
-                if (y == tilesY - 1){
+                if (y == tilesY - 1) {
                     tessellator.setNormal(0.0F, 1.0F, 0.0F);
                     final double subV = paintingBack.getSubIconV(1 / 16f);
                     tessellator.addVertexWithUV(minX, maxY, minZ, backMaxU, backMinV);
@@ -71,7 +67,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
                     tessellator.addVertexWithUV(maxX, maxY, maxZ, backMinU, subV);
                     tessellator.addVertexWithUV(maxX, maxY, minZ, backMinU, backMinV);
                 }
-                if (y == 0){
+                if (y == 0) {
                     tessellator.setNormal(0.0F, -1F, 0.0F);
                     final double subV = paintingBack.getSubIconV(15 / 16f);
                     tessellator.addVertexWithUV(minX, minY, minZ, backMaxU, subV);
@@ -79,7 +75,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
                     tessellator.addVertexWithUV(maxX, minY, maxZ, backMinU, backMaxV);
                     tessellator.addVertexWithUV(minX, minY, maxZ, backMaxU, backMaxV);
                 }
-                if (x == tilesX - 1){
+                if (x == tilesX - 1) {
                     tessellator.setNormal(-1F, 0.0F, 0.0F);
                     final double subU = paintingBack.getSubIconU(1 / 16f);
                     tessellator.addVertexWithUV(maxX, maxY, maxZ, backMinU, backMinV);
@@ -87,7 +83,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
                     tessellator.addVertexWithUV(maxX, minY, minZ, subU, backMaxV);
                     tessellator.addVertexWithUV(maxX, maxY, minZ, subU, backMinV);
                 }
-                if (x == 0){
+                if (x == 0) {
                     tessellator.setNormal(1.0F, 0.0F, 0.0F);
                     final double subU = paintingBack.getSubIconU(15 / 16f);
                     tessellator.addVertexWithUV(minX, maxY, maxZ, subU, backMinV);
@@ -102,82 +98,74 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
 
     }
 
-    private void setupPaintingBrightness(EntityPainting entity, float centerX, float centerY)
-    {
+    private void setupPaintingBrightness(EntityPainting entity, float centerX, float centerY) {
         int worldX = MathHelper.floor(entity.x);
-        int worldY = MathHelper.floor(entity.y + (double)(centerY / 16F));
+        int worldY = MathHelper.floor(entity.y + (double) (centerY / 16F));
         int worldZ = MathHelper.floor(entity.z);
-        if(entity.direction == 0)
-        {
-            worldX = MathHelper.floor(entity.x + (double)(centerX / 16F));
-        }
-        if(entity.direction == 1)
-        {
-            worldZ = MathHelper.floor(entity.z - (double)(centerX / 16F));
+        if (entity.direction == 0) {
+            worldX = MathHelper.floor(entity.x + (double) (centerX / 16F));
         }
-        if(entity.direction == 2)
-        {
-            worldX = MathHelper.floor(entity.x - (double)(centerX / 16F));
+        if (entity.direction == 1) {
+            worldZ = MathHelper.floor(entity.z - (double) (centerX / 16F));
         }
-        if(entity.direction == 3)
-        {
-            worldZ = MathHelper.floor(entity.z + (double)(centerX / 16F));
+        if (entity.direction == 2) {
+            worldX = MathHelper.floor(entity.x - (double) (centerX / 16F));
         }
-        float brightness = entity.world.getLightBrightness(worldX, worldY, worldZ);
-        if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) {
-            LightmapHelper.setLightmapCoord(entity.world.getLightmapCoord(worldX, worldY, worldZ, entity.world.getBlockLightValue(worldX, worldY, worldZ)));
-        	brightness = 1.0f;
+        if (entity.direction == 3) {
+            worldZ = MathHelper.floor(entity.z + (double) (centerX / 16F));
         }
-        GL11.glColor3f(brightness, brightness, brightness);
+        GLRenderer.setLightmapCoord1i(entity.world.getLightmapCoord(worldX, worldY, worldZ, entity.world.getBlockLightValue(worldX, worldY, worldZ)));
+        GLRenderer.setColor3f(1f, 1f, 1f);
     }
 
     @Override
-    public void render(@NotNull Tessellator tessellator, @NotNull EntityPainting entity, double x, double y, double z, float yaw, float partialTick) {
-        rand.setSeed(187L);
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float)x, (float)y, (float)z);
-        GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+    public void render(@NotNull TessellatorGeneral tessellator, @NotNull EntityPainting entity, double x, double y, double z, float yaw, float partialTick) {
+        this.rand.setSeed(187L);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         ArtType art = entity.art;
         float scale = 0.0625F;
-        GL11.glScalef(scale, scale, scale);
+        GLRenderer.modelM4f().scale(scale, scale, scale);
         renderArt(tessellator, entity, art.sizeX, art.sizeY, TextureRegistry.getTexture(art.texture));
         ItemStack borderStack = entity.getBorderStack();
-        if (borderStack != null){
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glBlendFunc(770, 771);
-            GL11.glColor4f(1f, 1f, 1f, 1f);
+        if (borderStack != null) {
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.setColor4f(1f, 1f, 1f, 1f);
             bindTexture(EntityPainting.getBorder(borderStack));
             renderBorder(entity, entity.art.sizeX, entity.art.sizeY);
-            GL11.glDisable(GL11.GL_BLEND);
+            GLRenderer.disableState(State.BLEND);
         }
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
-        GL11.glPopMatrix();
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.popFrame();
     }
+
     private void renderBorder(EntityPainting entity, int sizeX, int sizeY) {
-        float negCenterX = (float)(-sizeX) / 2.0f;
-        float negCenterY = (float)(-sizeY) / 2.0f;
+        float negCenterX = (float) (-sizeX) / 2.0f;
+        float negCenterY = (float) (-sizeY) / 2.0f;
         float minZ = -0.6f;
         float maxZ = 0.5f;
         int width = sizeX / 16;
         int height = sizeY / 16;
         for (int x = 0; x < width; ++x) {
             for (int y = 0; y < height; ++y) {
-                float maxX = negCenterX + (float)((x + 1) * 16);
-                float minX = negCenterX + (float)(x * 16);
-                float maxY = negCenterY + (float)((y + 1) * 16);
-                float minY = negCenterY + (float)(y * 16);
+                float maxX = negCenterX + (float) ((x + 1) * 16);
+                float minX = negCenterX + (float) (x * 16);
+                float maxY = negCenterY + (float) ((y + 1) * 16);
+                float minY = negCenterY + (float) (y * 16);
 
-                if (x == width-1){
+                if (x == width - 1) {
                     maxX += 0.1f;
                 }
-                if (x == 0){
+                if (x == 0) {
                     minX -= 0.1f;
                 }
-                if (y == height-1){
+                if (y == height - 1) {
                     maxY += 0.1f;
                 }
-                if (y == 0){
+                if (y == 0) {
                     minY -= 0.1f;
                 }
 
@@ -185,15 +173,15 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
 
                 int index = getIndex(width - x - 1, height - y - 1, width, height);
 
-                float u = (index%4)/4f;
-                float v = (index/4)/4f;
+                float u = (index % 4) / 4f;
+                float v = (index / 4) / 4f;
 
                 float minU = u + 0.25f;
                 float maxU = u;
                 float minV = v + 0.25f;
                 float maxV = v;
 
-                Tessellator tessellator = Tessellator.instance;
+                TessellatorGeneral tessellator = GLRenderer.getTessellator();
                 tessellator.startDrawingQuads();
                 tessellator.setNormal(0.0f, 0.0f, 1.0f);
                 tessellator.addVertexWithUV(maxX, minY, minZ, maxU, minV);
@@ -201,9 +189,9 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
                 tessellator.addVertexWithUV(minX, maxY, minZ, minU, maxV);
                 tessellator.addVertexWithUV(maxX, maxY, minZ, maxU, maxV);
 
-                float f = 1/64f;
+                float f = 1 / 64f;
 
-                if (y == 0){
+                if (y == 0) {
                     minU = u;
                     maxU = u + 0.25f;
                     minV = v + 0.25f - f;
@@ -216,7 +204,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
                     tessellator.addVertexWithUV(maxX, minY, minZ, minU, maxV);
 
                 }
-                if (y == height-1){
+                if (y == height - 1) {
                     minU = u;
                     maxU = u + 0.25f;
                     minV = v + f;
@@ -228,7 +216,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
                     tessellator.addVertexWithUV(minX, maxY, maxZ, maxU, maxV);
                     tessellator.addVertexWithUV(maxX, maxY, maxZ, minU, maxV);
                 }
-                if (x == 0){
+                if (x == 0) {
                     minU = u + 0.25f - f;
                     maxU = u + 0.25f;
                     minV = v;
@@ -240,7 +228,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
                     tessellator.addVertexWithUV(minX, minY, maxZ, minU, maxV);
                     tessellator.addVertexWithUV(minX, maxY, maxZ, minU, minV);
                 }
-                if (x == width-1){
+                if (x == width - 1) {
                     minU = u + f;
                     maxU = u;
                     minV = v;
@@ -258,53 +246,54 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
         }
     }
 
-    private int getIndex(int x, int y, int width, int height){
-        if (width == 1 && height == 1){ // 1x1
+    private int getIndex(int x, int y, int width, int height) {
+        if (width == 1 && height == 1) { // 1x1
             return 15;
         }
-        if (width == 1){ // Short
-            if (y == 0){
+        if (width == 1) { // Short
+            if (y == 0) {
                 return 3;
             }
-            if (y == height-1){
+            if (y == height - 1) {
                 return 11;
             }
             return 7;
         }
-        if (height == 1){ // Skinny
-            if (x == 0){
+        if (height == 1) { // Skinny
+            if (x == 0) {
                 return 12;
             }
-            if (x == width-1){
+            if (x == width - 1) {
                 return 14;
             }
             return 13;
         }
-        if (x == 0 && y == 0){
+        if (x == 0 && y == 0) {
             return 0;
         }
-        if (x == 0 && y == height-1){
+        if (x == 0 && y == height - 1) {
             return 8;
         }
-        if (x == width-1 && y == 0){
+        if (x == width - 1 && y == 0) {
             return 2;
         }
-        if (x == width-1 && y == height-1){
+        if (x == width - 1 && y == height - 1) {
             return 10;
         }
-        if (x == 0){
+        if (x == 0) {
             return 4;
         }
-        if (x == width-1){
+        if (x == width - 1) {
             return 6;
         }
-        if (y == 0){
+        if (y == 0) {
             return 1;
         }
-        if (y == height-1){
+        if (y == height - 1) {
             return 9;
         }
         return 5;
     }
+
     private final Random rand;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
index f513d37cb..579c03eeb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
@@ -2,62 +2,59 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.joml.Math;
 
-public class EntityRendererSprite<T extends Entity> extends EntityRenderer<T>
-{
-    private IconCoordinate itemIconIndex;
+public class EntityRendererSprite<T extends Entity> extends EntityRenderer<T> {
+    private final IconCoordinate itemIconIndex;
     private float scale = 1;
     private boolean fullBright = false;
 
-    public EntityRendererSprite(Item item){
+    public EntityRendererSprite(Item item) {
         this(ItemModelDispatcher.getInstance().getDispatch(item).getIcon(null, item.getDefaultStack()));
     }
-    public EntityRendererSprite(IconCoordinate i)
-    {
-        itemIconIndex = i;
+
+    public EntityRendererSprite(IconCoordinate i) {
+        this.itemIconIndex = i;
     }
 
-    public EntityRendererSprite<T> setFullBright(){
-        fullBright = true;
+    public EntityRendererSprite<T> setFullBright() {
+        this.fullBright = true;
         return this;
     }
-    public EntityRendererSprite<T> setScale(float scale){
+
+    public EntityRendererSprite<T> setScale(float scale) {
         this.scale = scale;
         return this;
     }
 
     @Override
-    public void render(@NotNull Tessellator tessellator, @NotNull T entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float) x, (float) y, (float) z);
-        if (fullBright){
-            GL11.glDisable(GL11.GL_LIGHTING);
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            if (LightmapHelper.isLightmapEnabled()){
-                LightmapHelper.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
-            }
+    public void render(@NotNull TessellatorGeneral tessellator, @NotNull T entity, double x, double y, double z,
+                       float yaw, float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        if (this.fullBright) {
+            GLRenderer.globalSetLightEnabled(false);
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            GLRenderer.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
         }
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glScalef(0.5F * scale, 0.5F * scale, 0.5F * scale);
-        itemIconIndex.parentAtlas.bind();
-        float f2 = (float) itemIconIndex.getIconUMin();
-        float f3 = (float) itemIconIndex.getIconUMax();
-        float f4 = (float) itemIconIndex.getIconVMin();
-        float f5 = (float) itemIconIndex.getIconVMax();
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.modelM4f().scale(0.5F * this.scale, 0.5F * this.scale, 0.5F * this.scale);
+        this.itemIconIndex.parentAtlas.bind();
+        float f2 = (float) this.itemIconIndex.getIconUMin();
+        float f3 = (float) this.itemIconIndex.getIconUMax();
+        float f4 = (float) this.itemIconIndex.getIconVMin();
+        float f5 = (float) this.itemIconIndex.getIconVMax();
         float f6 = 1.0F;
         float f7 = 0.5F;
         float f8 = 0.25F;
-        GL11.glRotatef(180F - renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(180F - this.renderDispatcher.viewLerpYaw));
+        GLRenderer.modelM4f().rotateX(Math.toRadians(-this.renderDispatcher.viewLerpPitch));
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         tessellator.addVertexWithUV(0.0F - f7, 0.0F - f8, 0.0D, f2, f5);
@@ -65,10 +62,10 @@ public class EntityRendererSprite<T extends Entity> extends EntityRenderer<T>
         tessellator.addVertexWithUV(f6 - f7, 1.0F - f8, 0.0D, f3, f4);
         tessellator.addVertexWithUV(0.0F - f7, 1.0F - f8, 0.0D, f2, f4);
         tessellator.draw();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
-        GL11.glPopMatrix();
-        if (fullBright){
-            GL11.glEnable(GL11.GL_LIGHTING);
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.popFrame();
+        if (this.fullBright) {
+            GLRenderer.globalSetLightEnabled(true);
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
index 3121e5187..f166ff51f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
@@ -2,61 +2,53 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.EntityPrimedTNT;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
-public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
-{
-    public EntityRendererTNT()
-    {
+public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT> {
+    public EntityRendererTNT() {
         super(0.5f);
     }
 
     @Override
-    public void render(@NotNull Tessellator tessellator, @NotNull EntityPrimedTNT tnt, double x, double y, double z, float yaw, float partialTick)
-    {
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float)x, (float)y, (float)z);
-        if(((float)tnt.fuse - partialTick) + 1.0F < 10F)
-        {
-            float f2 = 1.0F - (((float)tnt.fuse - partialTick) + 1.0F) / 10F;
-            if(f2 < 0.0F)
-            {
+    public void render(@NotNull TessellatorGeneral tessellator, @NotNull EntityPrimedTNT tnt, double x, double y, double z, float yaw, float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        if (((float) tnt.fuse - partialTick) + 1.0F < 10F) {
+            float f2 = 1.0F - (((float) tnt.fuse - partialTick) + 1.0F) / 10F;
+            if (f2 < 0.0F) {
                 f2 = 0.0F;
             }
-            if(f2 > 1.0F)
-            {
+            if (f2 > 1.0F) {
                 f2 = 1.0F;
             }
             f2 *= f2;
             f2 *= f2;
             float f4 = 1.0F + f2 * 0.3F;
-            GL11.glScalef(f4, f4, f4);
+            GLRenderer.modelM4f().scale(f4, f4, f4);
         }
-        float f3 = (1.0F - (((float)tnt.fuse - partialTick) + 1.0F) / 100F) * 0.8F;
-        TextureRegistry.blockAtlas.bind();
-        float brightness = tnt.getBrightness(partialTick);
-        if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
+        float f3 = (1.0F - (((float) tnt.fuse - partialTick) + 1.0F) / 100F) * 0.8F;
+        TextureRegistry.worldAtlas.bind();
         BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.TNT);
-        model.renderStandalone(tessellator, 0, brightness, 1, null);
-        if((tnt.fuse / 5) % 2 == 0)
-        {
+        model.renderStandalone(tessellator, 0, tnt.getLightmap(partialTick));
+        if ((tnt.fuse / 5) % 2 == 0) {
             GL11.glDisable(GL11.GL_TEXTURE_2D);
-            GL11.glDisable(GL11.GL_LIGHTING);
-            GL11.glEnable(GL11.GL_BLEND);
+            GLRenderer.globalSetLightEnabled(false);
+            GLRenderer.enableState(State.BLEND);
             GL11.glBlendFunc(770, 772);
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, f3);
-            model.renderStandalone(tessellator, 0, 1.0F, 1, null);
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            GL11.glDisable(GL11.GL_BLEND);
-            GL11.glEnable(GL11.GL_LIGHTING);
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, f3);
+            model.renderStandalone(tessellator, 0, tnt.getLightmap(partialTick));
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            GLRenderer.disableState(State.BLEND);
+            GLRenderer.globalSetLightEnabled(true);
             GL11.glEnable(GL11.GL_TEXTURE_2D);
         }
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
     }
 }
